// I3202 ILLUMINANT LCD(HX8347) Library. by NKJ 2010.01.29.

#define RGB(r,g,b)   ( ((r<<8)&0xf800)| ((g<<3)&0x07e0) | (b>>3) )


void LcdSetReg(unsigned char reg, unsigned char cmd)
{            
  LcdCs_H;

  LcdRs_L;   //register
  LcdData=reg;
  LcdWr_H;
  LcdWr_L; 
  
  LcdRs_H;   //command
  LcdData=cmd;
  LcdWr_H;
  LcdWr_L;

  LcdCs_L;
}

unsigned int LcdGetReg(unsigned char reg)
{ 
  unsigned int cmd;

  LcdCs_H;

  LcdRs_L;   //register
  LcdData=reg;
  LcdWr_H;
  LcdWr_L; 

  GPIOC->CRL=0x44444444;   // LCD_D0 ~ LCD_D7 : INPUT_FLOATING
  GPIOC->CRH=0x44444444;   // LCD_D8 ~ LCD_D15 : INPUT_FLOATING

  LcdRs_H;   //command
  LcdRd_H;
  cmd=GPIOC->IDR;  
  LcdRd_L;

  LcdCs_L;
                              
  GPIOC->CRL=0x33333333;   // LCD_D0 ~ LCD_D7 : OUTPUT_PUSH-PULL  
  GPIOC->CRH=0x33333333;   // LCD_D8 ~ LCD_D15 : OUTPUT_PUSH-PULL  

  return cmd;
}

void LcdInit(void)
{                   
  LcdCs_L; LcdWr_L; LcdRd_L;  
  
  GPIOC->CRL=0x33333333;   // LCD_D0 ~ LCD_D7 : OUTPUT_PUSH-PULL  
  GPIOC->CRH=0x33333333;   // LCD_D8 ~ LCD_D15 : OUTPUT_PUSH-PULL  
  
  LcdReset_H;
  mdelay(10);
  LcdReset_L;
  mdelay(150);

  
  LcdSetReg(0x46,0xA4);    
  LcdSetReg(0x47,0x53);    
  LcdSetReg(0x48,0x00);    
  LcdSetReg(0x49,0x44);    
  LcdSetReg(0x4A,0x04);    
  LcdSetReg(0x4B,0x67);    
  LcdSetReg(0x4C,0x33);    
  LcdSetReg(0x4D,0x77);    
  LcdSetReg(0x4E,0x12);    
  LcdSetReg(0x4F,0x4C);    
  LcdSetReg(0x50,0x46);    
  LcdSetReg(0x51,0x44);    
  
//240x320 window setting 
  
  LcdSetReg(0x02,0x00);   // Column address start2 
  LcdSetReg(0x03,0x00);   // Column address start1 
  LcdSetReg(0x04,0x00);   // Column address end2 
  LcdSetReg(0x05,0xEF);   // Column address end1 
  LcdSetReg(0x06,0x00);   // Row address start2 
  LcdSetReg(0x07,0x00);   // Row address start1  
  LcdSetReg(0x08,0x01);   // Row address end2 
  LcdSetReg(0x09,0x3F);   // Row address end1 
  
// Display Setting  
 
  LcdSetReg(0x01,0x06);  // IDMON=0, INVON=1, NORON=1, PTLON=0 
 
  LcdSetReg(0x16,0xc8);  // MY=1, MX=1, MV=0, ML=0, BGR=1, TEON=0   // ι
//  LcdSetReg(0x16,0xa8);  // MY=1, MX=0, MV=1, ML=0, BGR=1, TEON=0   //ι
  
  LcdSetReg(0x38,0x00);    // RGB_EN=0, use MPU Interface 
 
  LcdSetReg(0x23,0x95);   // N_DC=1001 0101 
  LcdSetReg(0x24,0x95);   // PI_DC=1001 0101 
  LcdSetReg(0x25,0xFF);   // I_DC=1111 1111  
  
  LcdSetReg(0x27,0x02);   // N_BP=0000 0010 
  LcdSetReg(0x28,0x02);   // N_FP=0000 0010 
  LcdSetReg(0x29,0x02);   // PI_BP=0000 0010 
  LcdSetReg(0x2A,0x02);   // PI_FP=0000 0010 
  LcdSetReg(0x2C,0x02);   // I_BP=0000 0010   
  LcdSetReg(0x2D,0x02);   // I_FP=0000 0010   
  
  LcdSetReg(0x3A,0x01);   // N_RTN=0000, N_NW=001  
  LcdSetReg(0x3B,0x00);   // PI_RTN=0000, PI_NW=000

  LcdSetReg(0x3C,0xF0);   // I_RTN=1111, I_NW
  LcdSetReg(0x3D,0x00);   // DIV=00 
  mdelay(20); 
  LcdSetReg(0x35,0x38);   // EQS=38h  
  LcdSetReg(0x36,0x78);   // EQP=78h 
 
  LcdSetReg(0x3E,0x38);   // SON=38h 
 
  LcdSetReg(0x40,0x0F);   // GDON=0Fh 
  LcdSetReg(0x41,0xF0);   // GDOFF 

// Power Supply Setting 
  LcdSetReg(0x19,0x49);    // CADJ=0100, CUADJ
  LcdSetReg(0x93,0x0F);   // RADJ=1111, 100% 
  mdelay(10); 
  LcdSetReg(0x20,0x40);     // BT=0100    
  LcdSetReg(0x1D,0x07);  // VC1=111 
  LcdSetReg(0x1E,0x00);  // VC3=000 
  LcdSetReg(0x1F,0x04);  // VRH=0100 
 
// VCOM Setting for CMO 3.2? Panel 
  LcdSetReg(0x44,0x4D);    // VCM=100 1101  
  LcdSetReg(0x45,0x11);    // VDV=1 0001 
  mdelay(10); 
 
  LcdSetReg(0x1C,0x04);   // AP=100 
  mdelay(20);  
  LcdSetReg(0x1B,0x18);   // GASENB=0, PON=1
  mdelay(40); 
    
  LcdSetReg(0x1B,0x10);   // GASENB=0, PON=1
  mdelay(40);      
  
  LcdSetReg(0x43,0x80);   //Set VCOMG=1 
  mdelay(100); 
// Display ON Setting 
  LcdSetReg(0x90,0x7F);    // SAP=0111 1111  
  LcdSetReg(0x26,0x04);   //GON=0, DTE=0, D=0
  mdelay(40); 
  LcdSetReg(0x26,0x24);   //GON=1, DTE=0, D=0
  LcdSetReg(0x26,0x2C);   //GON=1, DTE=0, D=
  mdelay(40); 
  
  LcdSetReg(0x26,0x3C);   //GON=1, DTE=1, D=
// Internal register setting 
  LcdSetReg(0x57,0x02);   //Test_Mode Enable 
  LcdSetReg(0x95,0x01);   // Set Display clock an
  LcdSetReg(0x57,0x00);   // Test_Mode Disable 

}


void LcdSetWindow(unsigned short x, unsigned short y, unsigned short width, unsigned short height)
{          
  unsigned short ex,ey;
  LcdSetReg(0x02,(x>>8)&0xff);  //Column Address Start Register HighByte
  LcdSetReg(0x03,x&0xff);       //Column Address Start Register LowByte
  LcdSetReg(0x06,(y>>8)&0xff);	//Row Address Start Register HighByte
  LcdSetReg(0x07,y&0xff);       //Row Address Start Register LowByte
  
  ex = x+width-1;
  ey = y+height-1;
  
  LcdSetReg(0x04,(ex>>8)&0xff); //Column Address End Register HighByte
  LcdSetReg(0x05,ex&0xff);      //Column Address End Register LowByte
  LcdSetReg(0x08,(ey>>8)&0xff); //Row Address End Register HighByte
  LcdSetReg(0x09,ey&0xff);	//Row Address End Register LowByte

}

/*
void LcdDataStart(void)
{
  LcdCs_H;

  LcdRs_L;   //register
  LcdData=0x0022; // SRAM Write Control
  LcdWr_H;
  LcdWr_L; 
  LcdRs_H;   //data
}
 
void LcdDataWrite(unsigned short rgb)  // format : (rrrrrggg gggbbbbb)bin
{
  LcdData=rgb;
  LcdWr_H;
  LcdWr_L;
} 
              

void LcdDataEnd(void)
{ 
  LcdCs_L;
}
*/
#define LcdDataStart()  {  LcdCs_H;  LcdRs_L;   LcdData=0x0022;   LcdWr_H;  LcdWr_L;   LcdRs_H;  }
#define LcdDataWrite(rgb)  { LcdData=rgb;  LcdWr_H;  LcdWr_L; }      // format : (rrrrrggg gggbbbbb)bin
#define LcdDataEnd()  LcdCs_L

void LcdSetDirection(unsigned short angle) // 0,90,180,270
{  
   switch(angle)
    {
      case 0:
      LcdSetReg(0x16,0xc8); 
      break;
      
      case 90:
      LcdSetReg(0x16,0xa8); 
      break;
      
      case 180:
      LcdSetReg(0x16,0x08); 
      break;
      
      case 270:
      LcdSetReg(0x16,0x68); 
      break;
      
      default:
      LcdSetReg(0x16,0xc8); 
      break;
    }
}